#ifndef _PROCESSED_H_
#define _PROCESSED_H_ 1

#include <vector>
#include "boost/shared_ptr.hpp"

/*
 * NB: We're allowing stl types over the interface because we are making assumptions 
 * that the clients are built with us.  This isn't really supposed to be used by any 
 * old random client.  
 */

class result_heirachy 
{
public:
	typedef boost::shared_ptr<result_heirachy> ptr;
	virtual ~result_heirachy() {};
	virtual class dbobj * get_node(int node_id) = 0;
	virtual std::vector<int> get_children(int node_id) = 0;
	virtual bool is_error() const = 0;
	virtual std::string error_text() = 0;
};

class dbobj
{
public:
	typedef boost::shared_ptr<dbobj> ptr;
	virtual ~dbobj() {}
	virtual std::string get_name() const = 0;
	virtual bool is_indirection(std::string & key) { return false; }
	virtual std::string get_display() = 0;
};

#endif